var GAME_WIDTH = 500;
var GAME_HEIGHT = 800;

var renderer;
var stage;

var canvas;

var background;
var foreground;
var startScreen;
var rated;
var BG_START = 0;
var inPosition = false;
var BG_START_RATE = 500;
var BG_RATE = 500;
var FG_RATE = 125;
var game_over = false;
var starting = true;
var instructionsOver = false;
var final_score_displayed = false;
var muted = false;
var collided = false;
var lastLane = 3;

var bunny;

var FRAMERATE = 0.08;
var VELOCITY = 100;

var lasttime;

var x, middle;
var y;
var ratio;
var horizontalVolatility = 2;

var time = 0;
var timeStr = '0:00';
var timer = setInterval(function(){

  if (instructionsOver) time++;
  if(time%5 === 0 && time > 0){
    gtag('event', 'UA-119697157-1', {
      'event_category': "engagement",
      'event_label': "Game_progress_" + time
    });
  }
  timeStr = getTimeStr(time);
}, 1000);

var distance = 0;

//hack for gapless looping
var musicLoop = new Audio('sounds/music_longloop2.mp3')
musicLoop.loop = true;


function preload() {
  createrenderer(); // Create renderer to test which kind in loading,
                    // do preloader animations (not implemented)
  window.addEventListener('deviceorientation', handleOrientation);
  
  var loader = PIXI.loader;
  PIXI.settings.PRECISION_FRAGMENT = PIXI.PRECISION.HIGH;
  loader
    .add('argh', 'sounds/argh.mp3')
    .add('crowdboo', 'sounds/crowdboo.mp3')
    .add('damnit', 'sounds/damnit.mp3')
    .add('freebeer', 'sounds/freebeer.mp3')
    .add('garble', 'sounds/garble.mp3')
    .add('oww', 'sounds/oww.mp3')
    .add('scream', 'sounds/scream.mp3')
    .add('yeahbaby', 'sounds/yeahbaby.mp3')
    .add("rated", "./images/bug.png")

  if (window.devicePixelRatio >= 2 &&
      renderer instanceof PIXI.WebGLRenderer) {
    // WebGL clause works around an apparent issues with
    // TilingSprites on high-res devices using canvas:
    // https://github.com/pixijs/pixi.js/issues/2083
    loader
      .add("background", "slideBG1x.png")
      .add('spineboy', './images/Johnny_assets_v03.json')
      .add('start', 'start1x.png');
  } else {
    loader
        .add("background", "slideBG1x.png")
        .add('spineboy', './images/Johnny_assets_v03.json')
        .add('start', 'start1x.png');
  }

  loader.once('complete', init);
  loader.load();
}


function createrenderer() {
  console.log("Create Renderer");
  
  var rendererOptions = {
    antialiasing: false,
    transparent: false,
    resolution: window.devicePixelRatio,
    autoResize: true,
  }
  
  // Create the canvas in which the game will show, and a
  // generic container for all the graphical objects
  renderer = PIXI.autoDetectRenderer(GAME_WIDTH, GAME_HEIGHT,
                                     rendererOptions);

  // Put the renderer on screen in the corner
  renderer.view.style.position = "absolute";
  renderer.view.style.top = "0px";
  renderer.view.style.left = "0px";


  x = middle = renderer.screen.width / 2;
  y = renderer.screen.height / 6;

  // The stage is essentially a display list of all game objects
  // for Pixi to render; it's used in resize(), so it must exist
  stage = new PIXI.Container();

  // Size the renderer to fill the screen
  resize();

  // Actually place the renderer onto the page for display
  document.body.appendChild(renderer.view);

  // Listen for and adapt to changes to the screen size, e.g.,
  // user changing the window or rotating their device
  window.addEventListener("resize", resize);
}


function init(e,res) {

  gtag('event', 'UA-119697157-1', {
    'event_category': "engagement",
    'event_label': "Game_Loaded"
  });

  // Create the scrolling background
  background = new PIXI.extras.TilingSprite(PIXI.loader.resources.background.texture, GAME_WIDTH, GAME_HEIGHT);
  background.zIndex = 0;

  stage.addChild(background);
  startScreen = new PIXI.Sprite(PIXI.loader.resources.start.texture)
  rated = new PIXI.Sprite(PIXI.loader.resources.rated.texture)

  stage.addChild(startScreen);
  stage.addChild(rated);

  rated.y = 750
  rated.x = 430
  rated.zIndex = 999999999
  rated.scale.set(0.7);

  bunny = new PIXI.spine.Spine(res.spineboy.spineData);

  bunny.scale.set(.2);
  bunny.x = x;
  bunny.y = -120;
  bunny.lane = 3;
  bunny.stateOfAnimation = '';
  bunny.collided = false;
  bunny.zIndex = 10;

  bunny.stateData.setMix('animation', 'Air_Punch', 0.2);
  
  stage.addChild(bunny);

  shake(bunny, 2, false);

  stage.addChild(graphics);
  stage.addChild(timeText);
  stage.addChild(distanceText);
  stage.addChild(feetText);
  stage.addChild(copyRightText);


  // Prepare for first frame of game loop/animation
  lasttime = new Date().getTime();
  requestAnimationFrame(animate);
  bunny.state.setAnimation(0, 'animation', true);

}

function onButtonDown(e){
    this.animationSpeed = 0.5;
}

function onButtonUp(e){
    this.animationSpeed = 1;
}

function resize() {

  // Determine which screen dimension is most constrained
  ratio = Math.min(window.innerWidth/GAME_WIDTH,
                   window.innerHeight/GAME_HEIGHT);

  // Scale the view appropriately to fill that dimension
  stage.scale.x = stage.scale.y = ratio;

  // Update the renderer dimensions
  renderer.resize(Math.ceil(GAME_WIDTH * ratio),
                  Math.ceil(GAME_HEIGHT * ratio));
}

var count = 0;
var obsCount = 0;
var obs = [];
var shaking = false;


var gameOverElement = document.getElementById("gameOver");
var finalTimeElement = document.getElementById("finalTime");
var finalDistanceElement = document.getElementById("finalDistance");
let instructions = document.getElementById('instructionsContainer');
let instructionsSound = document.getElementById('playButton');
let instructionsMute = document.getElementById('playButtonMute');

function animate() {
  //moving the scoreboard distance number as it grows
  if (distance >= 9) distanceText.x = 52;
  if (distance >= 99) distanceText.x = 32;
  if (distance >= 999) distance.x = 3;

  if(shaking && !game_over){

    if(inPosition){
      if(count % 2 === 0){
        bunny.updateShake();
      }      
    }


    // If johnny is in place then position him in fixed place
    if(bunny.y <= y && !inPosition){
      bunny.y = bunny.y+5;
    } else {
      
      bunny.y = y;

      if(!inPosition){
        instructions.style.position = 'fixed';
        instructions.style.display = 'flex';
        instructionsSound.addEventListener('click', function(){
          musicLoop.play();
          PIXI.loader.resources.freebeer.sound.play();
          gtag('event', 'UA-119697157-1', {
            'event_category': "engagement",
            'event_label': "Game_Started"
          });
          bunny.state.setAnimation(0, 'Air_Punch', false);
          bunny.state.addAnimation(0, 'animation', true, 0);
          setTimeout(function(){ 
            instructionsOver = true;
          }, 2500);
          instructions.style.display = 'none';
        })
        instructionsMute.addEventListener('click', function(){
          muted = true;
          gtag('event', 'UA-119697157-1', {
            'event_category': "engagement",
            'event_label': "Game_Started"
          });
          bunny.state.setAnimation(0, 'Air_Punch', false);
          bunny.state.addAnimation(0, 'animation', true, 0);
          setTimeout(function(){ 
            instructionsOver = true;
          }, 2500);
          instructions.style.display = 'none';
        })



        inPosition = true;
      }
    }
  }

  if (game_over){
    // clear the timer
    clearInterval(timer);

    // slow down the slide
    if(BG_RATE > 0){
      BG_RATE = BG_RATE * 0.97
    } else if(BG_RATE < 2){
      BG_RATE = 0;
    }

    // display final score
    if(!final_score_displayed){
      gtag('event', 'UA-119697157-1', {
        'event_category': "engagement",
        'event_label': "Game_Lost"
      });

      finalTimeElement.innerHTML = timeStr;
      finalDistanceElement.innerHTML = distance;
      gameOverElement.style.visibility = 'visible';
      gameOverElement.style.opacity = '1';
      gameOverElement.style.zIndex = 100;
      final_score_displayed = true
    }
  };

  if (!game_over) {
    if (count % 5 === 0 && instructionsOver) {
      let increment = 1 + (BG_RATE - BG_START_RATE) / BG_START_RATE;
      distance = Math.round(distance + increment);
      distanceText.setText(distance);
    }
    timeText.setText(timeStr);
  } else {
    musicLoop.pause();
    musicLoop.currentTime = 0;
  }

  // handle the edges of the slide
  if(shaking && instructionsOver){
    if (bunny.lane === 1){
      if(!game_over){
        bunny.stateOfAnimation = 'death';
        bunny.state.setAnimation(0, 'superman_v02_left', false);

        if (!PIXI.sound._sounds.argh.isPlaying && !muted) {
          PIXI.sound.play('argh');
        }
      }
      game_over = true;
      bunny.x -= 10;
    } else if(bunny.lane === 5) {
      if(!game_over){
        bunny.stateOfAnimation = 'jump';
        bunny.state.setAnimation(0, 'superman_v01_right', false);

        if (!PIXI.sound._sounds.argh.isPlaying && !muted) {
          PIXI.sound.play('argh');
        }
      }
      game_over = true;
      bunny.x += 10;
    }
  }

  if (lastLane !== bunny.lane && !game_over) {
    debouncedLean(bunny.lane);
    lastLane = bunny.lane;
  }

  count += 1;

  // Determine seconds elapsed since last frame
  var currtime = new Date().getTime();
  var delta = (currtime-lasttime)/1000;

  // Scroll the terrain once the game has loaded. Move start screen off at same time as other screen.
  if(starting){
    if(BG_START < BG_RATE){
      BG_START = (BG_START * 1.03) + 1
    } else if(BG_START >= BG_RATE){
      BG_START = BG_RATE
      if(startScreen.y < -startScreen.height){
        starting = false;
        shaking = true;
      }
    }

    startScreen.y -= BG_START*delta;
    background.tilePosition.y -= BG_START*delta;
    background.tilePosition.y %= background.texture.orig.height
  } else {
    background.tilePosition.y -= BG_RATE*delta;
    background.tilePosition.y %= background.texture.orig.height
  }




  // every 70 frames throw a new obstacle in the path
  if (count % 70 === 0 && !game_over && !starting && instructionsOver) {
    obs.push(new Obstacle(GAME_WIDTH, GAME_HEIGHT))
  }

  // inscrease speed
  if (count % 3 === 0 && !game_over && instructionsOver) {
    BG_RATE++;
  }

  for (var i = obs.length - 1; i >= 0; i--) {
    // add obstacle to the screen
    stage.addChild(obs[i].show())

    // sort the children on stage
    stage.children.sort(function(a,b) {
      a.zIndex = a.zIndex || 0;
      b.zIndex = b.zIndex || 0;
      return a.zIndex - b.zIndex
    })
    // move the obstacle according to the speed of the background
    obs[i].update(BG_RATE*delta);

    if (obs[i].hits(bunny)) {
        game_over = true;
        bunny.stateOfAnimation = 'dead';
        if (!PIXI.loader.resources.crowdboo.sound.isPlaying && !muted) PIXI.loader.resources.crowdboo.sound.play();

        switch(obs[i].obstacleType) {
          //squirrel
          case 0:
              if (!PIXI.loader.resources.damnit.sound.isPlaying && !collided) {
                if(!muted) PIXI.loader.resources.damnit.sound.play() ;
                
                bunny.state.setAnimation(0, 'collide', false);
                collided = true;
              }
              break;
          case 1:
              if (!PIXI.loader.resources.oww.sound.isPlaying && !collided) {
                if(!muted) PIXI.loader.resources.oww.sound.play();
                console.log('hit')
                bunny.state.setAnimation(0, 'crash_v01', false);
                collided = true;
              }
              break;
          case 2:
              if (!PIXI.loader.resources.oww.sound.isPlaying && !collided) {
                if(!muted) PIXI.loader.resources.oww.sound.play();
                console.log('hit')
                bunny.state.setAnimation(0, 'crash_v01', false);
                collided = true;
              }
              break;
          case 3:
              if (!PIXI.loader.resources.oww.sound.isPlaying && !collided) {
                if(!muted) PIXI.loader.resources.damnit.sound.play();
                console.log('hit')
                bunny.state.setAnimation(0, 'collide', false);
                collided = true;
              }
              break;
          case 4:
              if (!PIXI.loader.resources.scream.sound.isPlaying && !collided) {
                if(!muted) PIXI.loader.resources.scream.sound.play();
                console.log('hit')
                bunny.state.setAnimation(0, 'collide', false);
                collided = true;
              }
              break;
          case 5:
              if (!PIXI.loader.resources.garble.sound.isPlaying && !collided) {
                if(!muted) PIXI.loader.resources.garble.sound.play();
                console.log('hit')
                bunny.state.setAnimation(0, 'collide', false);
                collided = true;
              }
              break;
          default:
              break;
      }
    }

    // remove obstascles that are offscreen
    if (obs[i].offscreen()) {
        // remove from stage.children
        stage.removeChild(obs[i].ob)
        // remove from obstacles array
        obs.splice(i,1)

        obsCount++
        if (obsCount % 5 === 0) if (!PIXI.loader.resources.yeahbaby.sound.isPlaying && !muted) PIXI.loader.resources.yeahbaby.sound.play();
    }
  }


  // Draw the stage and prepare for the next frame
  renderer.render(stage);
  requestAnimationFrame(animate);
  lasttime = currtime;

}
// var lastGamma = 0
function handleOrientation(event) {
    

    if (game_over) return;
    var verticalTilt = event.beta;
    var horizontalTilt = event.gamma; // In degree in the range [-90,90]

    horizontalTiltR = horizontalTilt/76
    if(event.gamma > 45){
      // horizontalTiltR = 0.6
    } else if(event.gamma < -45){
      // horizontalTiltR = -0.6
    }

    // determine the lane of mr. knoxville
    if(horizontalTiltR <= -0.6){
      bunny.lane = 1
    } else if(horizontalTiltR > -0.6 && horizontalTiltR <= -0.2){
      bunny.lane = 2
    } else if(horizontalTiltR > -0.2 && horizontalTiltR <= 0.2){
      bunny.lane = 3
    } else if(horizontalTiltR > 0.2 && horizontalTiltR <= 0.6){
      bunny.lane = 4
    } else if(horizontalTiltR > 0.6){
      bunny.lane = 5
    }

    bunny.rotation = -horizontalTiltR;
    bunny.x = x + horizontalTilt * horizontalVolatility;
    bunny.updateX(bunny.x);
}

//restart function
function restart() {
  gtag('event', 'UA-119697157-1', {
    'event_category': "engagement",
    'event_label': "Game_Restarted"
  });
    instructionsOver = false
    BG_RATE = 600;
    BG_START = 0;

    bunny.x = x;
    bunny.y = y;
    bunny.lane = 3
    bunny.rotation = 0;
    bunny.collided = false;
    bunny.stateOfAnimation = '';

    distanceText.x = 70;
    distanceText.setText(0);
    count = 0;
    distance = 0;

    finalTimeElement.innerHTML = 0;
    game_over = false;
    gameOverElement.style.opacity = 0;
    gameOverElement.style.visibility = 'hidden';
    gameOverElement.style.zIndex = -5;
    final_score_displayed = false;
    collided = false;
    
    shaking = false;
    time = 0;
    timeStr = '0:00';
    timeText.setText(timeStr);
    timer = setInterval(function(){ 
      time++;
      if(time%5 === 0 && time > 0){
        gtag('event', 'UA-119697157-1', {
          'event_category': "engagement",
          'event_label': "Game_progress_" + time
        });
      }
      timeStr = getTimeStr(time);
    }, 1000);
    startScreen.y = -710
    starting = true;


    bunny.state.setAnimation(0, 'Air_Punch', false);
    bunny.state.addAnimation(0, 'animation', true, 0);
    if(!muted){
      musicLoop.play();
    }
    setTimeout(function(){ 
      instructionsOver = true;
    }, 2500);

    // remove obstacles from stage
    obs.forEach((obj) =>{
      stage.removeChild(obj.ob)
    })
    // reset obstacle array.
    obs = [];
    obsCount = 0;
}

function getTimeStr(time) {
  return parseInt(time / 60) + ':' + (time % 60 < 10 ? '0' : '') + (time % 60);
}

const debounce = (fn, time) => {
  let timeout;

  return function() {
    const functionCall = () => fn.apply(this, arguments);
    
    clearTimeout(timeout);
    timeout = setTimeout(functionCall, time);
  }
}

function lean(newLane) {
    if (bunny.stateOfAnimation === 'dead') return;
    if(newLane === 2){
      console.log('lean left')
      bunny.state.setAnimation(0, 'Left_Drive_short', false);
    } else if(newLane === 4) {
      console.log('lean right')
      bunny.state.setAnimation(0, 'right_drive_short', false);
    } else {
      console.log('upright');
      bunny.state.setAnimation(0, 'animation', false);
    }
}

var debouncedLean = debounce(lean, 300);